#include "U2.h"
#include "fix.h"

bit	DmaTxFlag;
bit	DmaRxFlag;

u8 T_AMT=0xFF,R_AMT=0xFF;

u8 xdata DmaTxBuffer[256];
u8 xdata DmaRxBuffer[256];

func DMA_TX_FUNC_ISR=0,DMA_RX_FUNC_ISR=0;

void DMA_Config(void)
{
	DMA_UR2T_CFG = 0x80;		//bit7 1:Enable Interrupt
	DMA_UR2T_STA = 0x00;
	DMA_UR2T_AMT = 0xff;		//设置传输总字节数：n+1
	DMA_UR2T_TXAH = (u8)((u16)&DmaTxBuffer >> 8);
	DMA_UR2T_TXAL = (u8)((u16)&DmaTxBuffer);
	DMA_UR2T_CR = 0x80;			//bit7 1:使能 UART2_DMA, bit6 1:开始 UART2_DMA 自动发送

	DMA_UR2R_CFG = 0x80;		//bit7 1:Enable Interrupt
	DMA_UR2R_STA = 0x00;
	DMA_UR2R_AMT = 0xff;		//设置传输总字节数：n+1
	DMA_UR2R_RXAH = (u8)((u16)&DmaRxBuffer >> 8);
	DMA_UR2R_RXAL = (u8)((u16)&DmaRxBuffer);
	DMA_UR2R_CR = 0xa1;			//bit7 1:使能 UART2_DMA, bit5 1:开始 UART2_DMA 自动接收, bit0 1:清除 FIFO
}


void SetTimer2Baudraye(u16 dat)  // 使用Timer2做波特率.
{
    AUXR &= ~(1<<4);    //Timer stop
    AUXR &= ~(1<<3);    //Timer2 set As Timer
    AUXR |=  (1<<2);    //Timer2 set as 1T mode
    T2H = dat / 256;
    T2L = dat % 256;
    IE2  &= ~(1<<2);    //禁止中断
    AUXR |=  (1<<4);    //Timer run enable
}

void UART2_config()    // 选择波特率, 2: 使用Timer2做波特率, 其它值: 无效.
{
    /*********** 波特率固定使用定时器2 *****************/
    if(1)
    {
        SetTimer2Baudraye((u16)(65536UL - (MAIN_Fosc / 4) / Baudrate2));

        S2CON &= ~(1<<7);   //8位数据, 1位起始位, 1位停止位, 无校验
//        IE2   |= 1;         //允许中断
        S2CON |= (1<<4);    //允许接收
        P_SW2 &= ~0x01;     //UART2 switch to: 0: P1.0 P1.1
        //P_SW2 |= 1;         //UART2 switch to: 1: P4.6 P4.7
    }
}

void UART2_DMA_Interrupt(void) interrupt 13
{
	if (DMA_UR2T_STA & 0x01)	//发送完成
	{
		DMA_UR2T_STA &= ~0x01;
		DmaTxFlag = 1;
		if (DMA_TX_FUNC_ISR){
			DMA_TX_FUNC_ISR();
		}
	}
	if (DMA_UR2T_STA & 0x04)	//数据覆盖
	{
		DMA_UR2T_STA &= ~0x04;
	}

	if (DMA_UR2R_STA & 0x01)	//接收完成
	{
		DMA_UR2R_STA &= ~0x01;
		DmaRxFlag = 1;
		if(DMA_RX_FUNC_ISR){
			DMA_RX_FUNC_ISR();
		}
	}
	if (DMA_UR2R_STA & 0x02)	//数据丢弃
	{
		DMA_UR2R_STA &= ~0x02;
	}
}
